package com.javacodegeeks.generate_zip_file;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

@WebListener
public class ContextListenerExecutorServiceInitializer implements ServletContextListener {

    public static final String THREAD_POOL_EXECUTOR = "executor";
    
    @Override
    public void contextInitialized(final ServletContextEvent sce) {
        sce.getServletContext().setAttribute(THREAD_POOL_EXECUTOR, Executors.newFixedThreadPool(2));
    }

    @Override
    public void contextDestroyed(final ServletContextEvent sce) {
        final ExecutorService executor = (ExecutorService) sce.getServletContext().getAttribute(THREAD_POOL_EXECUTOR);
        executor.shutdown();
    }
}
